Index: /trunk/LMDZ.GENERIC/libf/phystd/N2broadprof_fn.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/N2broadprof_fn.F90	(revision 253)
+++ /trunk/LMDZ.GENERIC/libf/phystd/N2broadprof_fn.F90	(revision 253)
@@ -0,0 +1,110 @@
+      subroutine N2broadprof_fn(tsurf,temp,popsk,play,plev,qvap)
+      implicit none
+
+!     creates a temperature profile for an N2-CO2 atmosphere
+!     a fine resolution grid is used for accuracy
+
+#include "dimensions.h"
+#include "dimphys.h"
+#include "comcstfi.h"
+#include "callkeys.h"
+
+      REAL play(nlayermx)   ! Pressure at the middle of the layers (Pa)
+      REAL plev(nlayermx+1) ! Intermediate pressure levels (pa)
+      REAL psurf,tsurf      
+!      REAL tcond(nlayermx)
+      REAL qvap(nlayermx)
+      REAL temp(nlayermx)   ! temperature at the middle of the layers
+
+      real, parameter :: Rstar   = 8.314
+      real, parameter :: ptriple = 518000.0
+      real, parameter :: latcond = 5.9e5     ! as in condense_co2
+      real, parameter :: mn      = 0.02801   ! molar mass of background gas (N2)
+      real, parameter :: mv      = 0.04401   ! molar mass of background gas (CO2)
+
+      real popsk(nlayermx)  ! this is dodgy as in rest of code, zpopsk(ngridmx,nlayermx)
+                            ! but kastprof requires 1D, so its ok I guess
+
+      real gamma,dqdlnT,dlnqdlnT,dlnpdlnT,dpdT,dln_p
+
+      integer l,iter
+
+      real sigma_loc,q_loc,vmr_loc,ppvar_loc,T_loc,p_loc
+      real Tcond
+      real Told,qold,pold
+
+      integer, parameter :: Niter = 2000
+
+      if(ngridmx.gt.1)then
+         print*,'DO NOT RUN KASTPROF IN 3D!!!'
+         call abort
+      end if
+
+      l=1
+
+      vmr_loc = 0.05 ! value at ground
+      q_loc   = vmr_loc*mv/mn
+      T_loc   = Tsurf
+
+      dln_p = log(pceil/plev(1))/Niter ! please check
+      do iter=1,Niter
+
+         sigma_loc = (pceil/plev(1))**(real(iter)/real(Niter))
+         p_loc     = plev(1)*sigma_loc
+
+         ppvar_loc = vmr_loc*p_loc
+         if(ppvar_loc.lt.ptriple)then
+            Tcond = (-3167.8)/(log(.01*ppvar_loc)-23.23)         ! Fanale's formula
+         else
+            Tcond = 684.2-92.3*log(ppvar_loc)+4.32*log(ppvar_loc)**2 ! liquid-vapour (CRC handbook 2003 data)
+         endif
+
+            if (T_loc.le.Tstrat)then
+               T_loc     = Tstrat            ! isothermal stratosphere
+            elseif(T_loc.le.Tcond)then
+
+               gamma     = cpp - q_loc*latcond/T_loc
+               dqdlnT    = (mv*latcond/(mn*T_loc) - gamma) & 
+                            / (latcond/T_loc + Rstar/(mn*q_loc))
+               dlnqdlnT  = (1./q_loc)*dqdlnT
+               dlnpdlnT  = mv*latcond/(Rstar*T_loc) - dlnqdlnT/(1. + q_loc*mn/mv)
+               dpdT      = (p_loc/T_loc)*dlnpdlnT
+               q_loc     = q_loc  + dqdlnT*dln_p/dlnpdlnT
+               vmr_loc   = q_loc*mn/mv ! needed for Tcond calc.
+               T_loc     = T_loc*(1 + dln_p/dlnpdlnT)
+               print*,T_loc
+            else
+               ! nothing doing; so dry convection
+               T_loc     = tsurf*(p_loc/plev(1))**rcp
+            endif
+
+            ! update true gridpoints when we reach them
+            if((p_loc.le.play(l)) .and. (l.le.nlayermx))then
+               temp(l)=T_loc
+               qvap(l)=q_loc
+               ! do an avg you lazy bastard
+!               temp(l)=T_loc*(p_loc-play(l))/(p_loc-pold)+Told*(play(l)-pold)/(p_loc-pold)
+!               qvap(l)=q_loc*(p_loc-play(l))/(p_loc-pold)+qold*(play(l)-pold)/(p_loc-pold)
+
+!               f=fA*(y2-y)/(y2-y1)+fB*(y-y1)/(y2-y1)
+
+!               print*,'l=',l
+!               print*,'temp(l)=',temp(l)
+!               print*,'qvap(l)=',qvap(l)
+
+
+               qvap(l)=0.05*mv/mn ! suface amount everywhere to test
+
+               l=l+1
+            endif
+
+            Told=T_loc
+            qold=q_loc
+            pold=p_loc
+
+      enddo ! vertical loop
+
+      print*,'---fin---'
+
+      return
+    end subroutine N2broadprof_fn
Index: /trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90	(revision 253)
@@ -1,6 +1,6 @@
-      subroutine aeropacity(ngrid,nlayer,nq,pplev,pq, &
-         aerosol,reffrad,QREFvis3d,QREFir3d,tau_col)
-
-       use radinc_h, only : naerkind
+      Subroutine aeropacity(ngrid,nlayer,nq,pplay,pplev,pq, &
+         aerosol,reffrad,QREFvis3d,QREFir3d,tau_col,cloudfrac,totcloudfrac,clearsky)
+
+       use radinc_h, only : naerkind, L_TAUMAX
                   
        implicit none
@@ -46,4 +46,5 @@
       INTEGER ngrid,nlayer,nq
 
+      REAL pplay(ngrid,nlayer)
       REAL pplev(ngrid,nlayer+1)
       REAL pq(ngrid,nlayer,nq)
@@ -53,5 +54,9 @@
       REAL QREFir3d(ngridmx,nlayermx,naerkind)
 
-      REAL tauref(ngrid), tau_col(ngrid)
+      REAL tau_col(ngrid)
+!      REAL tauref(ngrid), tau_col(ngrid)
+
+      real cloudfrac(ngridmx,nlayermx)
+      real aerosol0
 
       INTEGER l,ig,iq,iaer
@@ -68,9 +73,17 @@
       CHARACTER(LEN=20) :: tracername ! to temporarily store text
 
-
-! identify tracers
+      ! for fixed dust profiles
+      real topdust, expfactor, zp
+      REAL taudusttmp(ngridmx) ! Temporary dust opacity used before scaling
+
+      ! BENJAMIN MODIFS
+      real CLFtot,CLF1,CLF2
+      real totcloudfrac(ngridmx)
+      logical clearsky
+
+      ! identify tracers
       IF (firstcall) THEN
 
-         ! are these tests of any real use?
+         ! are these tests of any real use ?
         IF(ngrid.NE.ngridmx) THEN
             PRINT*,'STOP in aeropacity!'
@@ -86,5 +99,4 @@
            stop
         endif
-
 
         do iq=1,nqmx
@@ -101,8 +113,17 @@
         write(*,*) "            i_h2oice=",i_h2oice
         
-        !if((i_h2oice.lt.1) .and. (naerkind.gt.1))then
-        !   print*,'naerkind > 1 but no h2o ice, this will not work.'
-        !   stop
-        !endif
+      if(watercond.and.(.not.aerofixed))then
+         if(naerkind.lt.2)then
+            print*,'Cannot have active H2O clouds with naerkind less than 2!'
+            call abort
+         endif
+      endif
+
+      if(dusttau.gt.0.0)then
+         if(naerkind.lt.3)then
+            print*,'Cannot have active dust with naerkind less than 3!'
+            call abort
+         endif
+      endif
 
         firstcall=.false.
@@ -110,71 +131,117 @@
 
 
-      aerosol(:,:,:)=0.0
-
       DO iaer = 1, naerkind ! Loop on aerosol kind (NOT tracer)
 !     ---------------------------------------------------------
-        aerkind: SELECT CASE (iaer)
-!==================================================================
-        CASE(1) aerkind                          ! CO2 ice (iaer=1)
+         aerkind: SELECT CASE (iaer)
+!==================================================================
+         CASE(1) aerkind                         ! CO2 ice (iaer=1)
 !==================================================================
 
 !       1. Initialization
-        CALL zerophys(ngrid*nlayer,aerosol(1,1,iaer))
+            aerosol(:,:,iaer)=0.0
 
 !       2. Opacity calculation
-        if (aerofixed.or.(i_co2ice.eq.0)) then !  CO2 ice cloud prescribed
-           do ig=1, ngrid
-              do l=1,nlayer
-                 aerosol(ig,l,iaer) =1.e-9
-              end do
-              aerosol(ig,14,iaer)=1.e-9 ! single cloud layer option
-           end do
-        else
-           DO ig=1, ngrid
-              DO l=1,nlayer
-                 aerosol(ig,l,iaer) =                   &
-                      (  0.75 * QREFvis3d(ig,l,iaer) /  &
-                      ( rho_co2 * reffrad(ig,l,iaer) )  ) * &
-                      ( pq(ig,l,i_co2ice) + 1.E-9 ) *   &
-                      ( pplev(ig,l) - pplev(ig,l+1) ) / g
-              ENDDO
-           ENDDO
-        end if
-
-!==================================================================
-        CASE(2) aerkind               ! Water ice crystals (iaer=2)
-!==================================================================
-
+            if (aerofixed.or.(i_co2ice.eq.0)) then !  CO2 ice cloud prescribed
+               do ig=1, ngrid
+                  do l=1,nlayer
+                     aerosol(ig,l,iaer)=1.e-9
+                  end do
+                  !aerosol(ig,12,iaer)=4.0 ! single cloud layer option
+               end do
+            else
+               DO ig=1, ngrid
+                  DO l=1,nlayer-1 ! to stop the rad tran bug
+
+                     aerosol0 =                         &
+                          (  0.75 * QREFvis3d(ig,l,iaer) /        &
+                          ( rho_co2 * reffrad(ig,l,iaer) )  ) *   &
+                          ( pq(ig,l,i_co2ice) + 1.E-9 ) *         &
+                          ( pplev(ig,l) - pplev(ig,l+1) ) / g
+                     aerosol0           = max(aerosol0,1.e-9)
+                     aerosol0           = min(aerosol0,L_TAUMAX)
+                     aerosol(ig,l,iaer) = aerosol0
+!                     aerosol(ig,l,iaer) = 0.0
+
+!        using cloud fraction
+!                     aerosol(ig,l,iaer) = -log(1 - CLF + CLF*exp(-aerosol0/CLF))
+!                     aerosol(ig,l,iaer) = min(aerosol(ig,l,iaer),L_TAUMAX)
+
+
+                  ENDDO
+               ENDDO
+            end if
+            
+!==================================================================
+         CASE(2) aerkind              ! Water ice / liquid (iaer=2)
+!==================================================================
 
 !       1. Initialization
-        CALL zerophys(ngrid*nlayer,aerosol(1,1,iaer))
+            aerosol(:,:,iaer)=0.0
 
 !       2. Opacity calculation
-!     if (1.eq.1) then
-     if (aerofixed.or.(i_h2oice.eq.0)) then
-!        print*,'No H2O clouds in the radiative transfer!'
-        do ig=1, ngrid
-           do l=1,nlayer
-              aerosol(ig,l,iaer) =1.e-9
-           end do
-           aerosol(ig,5,iaer)=1.e-9 ! single cloud layer option
-        end do
-     else
-        DO ig=1, ngrid
-          DO l=1,nlayer
-             aerosol(ig,l,iaer) =                   &
-            (  0.75 * QREFvis3d(ig,l,iaer) /        &
-              ( rho_ice * reffrad(ig,l,iaer) )  ) * &
-              ( pq(ig,l,i_h2oice) + 1.E-9 ) *   &
-              ( pplev(ig,l) - pplev(ig,l+1) ) / g
-          ENDDO
-        ENDDO
-
-     end if
-
-
-!==================================================================
-        END SELECT aerkind
-
+            if (aerofixed.or.(i_h2oice.eq.0).or.clearsky) then
+               do ig=1, ngrid ! to stop the rad tran bug
+                  do l=1,nlayer
+                     aerosol(ig,l,iaer) =1.e-9
+                  end do
+               end do
+            else
+               do ig=1, ngrid
+                  do l=1,nlayer-1 ! to stop the rad tran bug
+
+                     if(CLFvarying)then
+                        CLF1    = max(cloudfrac(ig,l),0.01)
+                        CLFtot  = max(totcloudfrac(ig),0.01)
+                        CLF2    = CLF1/CLFtot 
+                        CLF2    = min(1.,CLF2)
+                     else
+                        CLF1=1.0
+                        CLF2=CLFfixval
+                     endif
+                     
+                     aerosol0 =                                   &
+                          (  0.75 * QREFvis3d(ig,l,iaer) /        &
+                          ( rho_ice * reffrad(ig,l,iaer) )  ) *   &
+                          ( pq(ig,l,i_h2oice) + 1.E-9 ) *         &
+                          ( pplev(ig,l) - pplev(ig,l+1) ) / g /   &
+                            CLF1
+
+                     aerosol(ig,l,iaer) = -log(1 - CLF2 + CLF2*exp(-aerosol0)) 
+                     ! why no division in exponential?
+                     ! because its already done in aerosol0
+                     
+                     aerosol(ig,l,iaer) = max(aerosol(ig,l,iaer),1.e-9)
+                     aerosol(ig,l,iaer) = min(aerosol(ig,l,iaer),aerosol0)                     
+                     
+                  enddo
+               enddo
+            end if
+
+
+!==================================================================
+         CASE(3) aerkind                            ! Dust (iaer=3)
+!==================================================================
+
+!       1. Initialization
+            aerosol(:,:,iaer)=0.0
+
+            topdust=10.0 ! km
+
+            print*,'WARNING, dust is experimental for Early Mars'
+
+!       2. Opacity calculation
+
+            do l=1,nlayer
+               do ig=1,ngrid-1 ! to stop the rad tran bug
+                  zp=700./pplay(ig,l)
+                  aerosol(ig,l,1)=(dusttau/700.)*(pplev(ig,l)-pplev(ig,l+1)) &
+                       *max( exp(.03*(1.-max(zp,1.))) , 1.E-3 ) &
+                       *QREFvis3d(ig,l,iaer) / QREFvis3d(ig,1,iaer) 
+                  ! takes into account particle variation
+              enddo
+            enddo
+
+!==================================================================
+         END SELECT aerkind
       ENDDO ! iaer (loop on aerosol kind)
 
@@ -183,5 +250,5 @@
 ! Column integrated visible optical depth in each point (used for diagnostic)
 
-      call zerophys(ngrid,tau_col)
+      tau_col(:)=0.0
       do iaer = 1, naerkind
          do l=1,nlayer
@@ -192,4 +259,27 @@
       end do
 
+      do ig=1, ngrid
+         do l=1,nlayer
+            do iaer = 1, naerkind
+               if(aerosol(ig,l,iaer).gt.1.e3)then
+                  print*,'WARNING: aerosol=',aerosol(ig,l,iaer)
+                  print*,'at ig=',ig,',  l=',l,', iaer=',iaer
+                  print*,'QREFvis3d=',QREFvis3d(ig,l,iaer)
+                  print*,'reffrad=',reffrad(ig,l,iaer)
+               endif
+            end do
+         end do
+      end do
+
+      do ig=1, ngrid
+         if(tau_col(ig).gt.1.e3)then
+            print*,'WARNING: tau_col=',tau_col(ig)
+            print*,'at ig=',ig
+            print*,'aerosol=',aerosol(ig,:,:)
+            print*,'QREFvis3d=',QREFvis3d(ig,:,:)
+            print*,'reffrad=',reffrad(ig,:,:)
+         endif
+      end do
+
       return
     end subroutine aeropacity
